﻿dhtmlxError.catchError("LoadXML", errorHandler);

function errorHandler(type, desc, erData) {
    dhtmlx.message({text: "Erro de XML!<br /><br />Contate o administrador do interno!"});
    return true;
}

function SMSTbrButton (data) {
	
	var smsTbrButton = {
			group: null,
			id:null,
			text:null,
			disable: false,
			icon: null,
			pos: 0,
			smsDefaultUI: null,
			init: function (data) {
				$.extend(this,data);
			},
			click: function (func){
				this.click = func;
			}
			
	};
	
	smsTbrButton.init(data);
	return smsTbrButton;
}

UIexport = {

		exportAction: function (self,type)
		{
			sub = self.layout;
			sub.progressOn();
			self.dataGrid.enableCSVAutoID(false);
			self.dataGrid.enableCSVHeader(true);
			self.dataGrid.setCSVDelimiter("|");
			self.dataGrid.setSerializationLevel(false,false,true,false,false,true);
			var stColWidth = "";
			for(iLaco = 0; iLaco < self.dataGrid.getColumnsNum(); iLaco++) {
				if (stColWidth != "") {
					stColWidth += ",";
				}
				stColWidth += self.dataGrid.getColWidth(iLaco);
			}
			var aux = (self.hasExcelId) ? '?id=' : '';
			var form = '<form id="form-csv" method="post" target="_blank" action="'+ getUrl() + '/default/' + type + aux + '">';
			form += '<textarea style="visibility: hidden" name="userdata">' + self.dataGrid.getUserData("","param") + '</textarea>';
			form += '<textarea style="visibility: hidden" name="criacao">' + self.dataGrid.getUserData("","criacao") + '</textarea>';
			form += '<textarea style="visibility: hidden" name="csv">' + self.dataGrid.serializeToCSV(true) + '</textarea>';
			form += '<textarea style="visibility: hidden" name="colsWidth">' + stColWidth + '</textarea>';
			form += "</form>";
			
			jQuery("body").append(form);
			jQuery('#form-csv').submit();
			jQuery('#form-csv').remove();
			sub.progressOff();
		},

		excel: function (self)
		{
			UIexport.exportAction(self,'excel');
		},
		
		pdf: function (self)
		{
			UIexport.exportAction(self,'pdf');
		}
};

function SMSDefaultUI (data) {
	
	var smsDefaultUI = {
		
		layout: null,
		layoutCell: null,
		toolbar: null,
		toolBar: null,
		dataGrid: null,
		tb: this.toolbar,
		buttons: [],
		countSeparator: 0,
		_defaultButtons: [],

        _init: function (data){
		
			var self = this;
			
			if(data != undefined)
				$.extend(this,data);
			
			this.popDefaultButtons();
			this.loadImages();
			this.doLayout();
			this.doToolbar();
			this.observerToolbar();
			this.doGrid();
			this.observerGrid();

		},
		
		popDefaultButtons: function (){
			this._defaultButtons['adicionar'] = new SMSTbrButton({ id: 'btnAdicionar',pos: 0, text: 'Adicionar', icon: 'adicionar.png',smsDefaultUI: this });
			this._defaultButtons['editar'] = new SMSTbrButton({ id: 'btnEditar',pos: 1, text: 'Editar', icon: 'editar.png', disable: true,smsDefaultUI: this });
			this._defaultButtons['excluir'] = new SMSTbrButton({ id: 'btnExcluir',pos: 2, text: 'Excluir', icon: 'apagar.png', disable: true,smsDefaultUI: this });
			this._defaultButtons['consultar'] = new SMSTbrButton({ id: 'btnConsultar',pos: 3, text: 'Consultar', icon: 'agenda.png', disable: true,smsDefaultUI: this });
			this._defaultButtons['executar'] = new SMSTbrButton({ id: 'btnExecutar',pos: 4, text: 'Executar', icon: 'play.png',smsDefaultUI: this });
			this._defaultButtons['ativar'] = new SMSTbrButton({ id: 'btnAtivar',pos: 0, text: 'Ativar', icon: 'pause.png',smsDefaultUI: this });
			this._defaultButtons['inativar'] = new SMSTbrButton({ id: 'btnInativar',pos: 0, text: 'Inativar', icon: 'stop.png',smsDefaultUI: this });
			this._defaultButtons['atualizar'] = new SMSTbrButton({ id: 'btnAtualizar',pos: 0, text: 'Atualizar', icon: 'atualizar.png',smsDefaultUI: this });
			this._defaultButtons['atualizar'].click(function (){
				this.smsDefaultUI.grid.refresh(this.smsDefaultUI);
			});
			
			this._defaultButtons['excel'] = new SMSTbrButton({ id: 'btnExcel',pos: 0, text: 'Planilha de Cálculo', icon: 'excel.png', disable: true, smsDefaultUI: this });
			this._defaultButtons['excel'].click(function (){
				UIexport.excel(self);
			});
			
			this._defaultButtons['pdf'] = new SMSTbrButton({ id: 'btnPdf',pos: 0, text: 'Pdf', icon: 'pdf.png', disable: true, smsDefaultUI: this });
			this._defaultButtons['pdf'].click(function (){
				UIexport.excel(self);
			});
		},
		
		loadImages: function (){
			dhtmlx.image_path = APP.appBaseUrl + '/dhtmlxSuite/imgs/';
		},
		
		doLayout: function (){
            this.layout = new dhtmlXLayoutObject({
                parent: document.body,
                pattern: '1C',
                cells: [
                    {
                        id: 'a',
                        text: '',
                        header: false
                    }
                ]
            });
            this.layout.progressOn();
			this.layoutCell = this.layout.cells('a');
		},

		doToolbar: function (){
			this.toolbar = this.layoutCell.attachToolbar();
			this.toolbar.setIconsPath(APP.appBaseUrl + 'images/');
			this._customToolbar();
			
			for(var x = 0; x < this.buttons.length; x++){
				
				if(typeof(this.buttons[x]) == "string"){
						if(this._defaultButtons[this.buttons[x]] != undefined){
							this._defaultButtons[this.buttons[x]].pos = x;
							this.toolbar.addSMSButton(this._defaultButtons[this.buttons[x]]);	
						} else{
							this.toolbar.addSMSSeparator(x);
						}
				}else {
					this.buttons[x].pos = x;
					this.toolbar.addSMSButton(this.buttons[x]);
				}
			}
		},
		
		observerToolbar: function (){
			
			var self = this;
			
			this.toolbar.attachEvent('onClick', function(id) {
					self.getButton(id).click();
			});
			
			this.toolbar.attachEvent('onStateChange', function(id, state) {
				if(self.toolBar.stateChange != undefined){
					self.toolBar.stateChange(id,state);
				}
			});
		},
		
		doGrid: function (){
			if(this.grid != null){
				this.dataGrid = this.layoutCell.attachGrid();
				
				this._customGrid();

				this.dataGrid.setSkin('dhx_skyblue');
                this.dataGrid.setIconsPath(APP.appBaseUrl + 'dhtmlxSuite/imgs/');
                this.dataGrid.setImagesPath(APP.appBaseUrl + 'dhtmlxSuite/codebase/imgs/');

                if(this.grid.header != undefined)
				this.dataGrid.setHeader(this.grid.header);
				
				if(this.grid.colTypes != undefined)
					this.dataGrid.setColTypes(this.grid.colTypes);
				
				if(this.grid.colSorting != undefined)
					this.dataGrid.setColSorting(this.grid.colSorting);
				
				if(this.grid.widths != undefined)
					this.dataGrid.setInitWidths(this.grid.widths);
				
				this.grid.editable = true;//(this.grid.editable != undefined) ? this.grid.editable : false;
				this.dataGrid.setEditable(this.grid.editable);
				
				if(this.grid.splitAt != undefined)
				this.dataGrid.splitAt(this.grid.splitAt);
				
				if(this.grid.enableEditEvents != undefined)
					this.dataGrid.enableEditEvents(this.grid.enableEditEvents);
				
				this.dataGrid.init();
				this.grid.refresh(this);
			}
		},
		
		observerGrid: function (){
			var self = this;
			this.dataGrid.attachEvent('onRowSelect', function(id, ind){
				if(self.grid.rowSelect != undefined)
					self.grid.rowSelect(self,id,ind);
				
				return;
			});
			
			this.dataGrid.attachEvent('onRowDblClicked', function(row, index) {
				if(self.grid.rowDblClicked != undefined)
					self.grid.rowDblClicked(self,row,index);
				return;
			});
			
		},
		
		_customToolbar: function (){
			var self = this;
			this.toolbar.addSMSButton = function (data){
				self.toolbar.addButton(data.id,data.pos,data.text,data.icon,data.icon);
				
				if(data.disable)
					self.toolbar.disableItem(data.id);
			};
			
			this.toolbar.addSMSSeparator = function (index){
				self.toolbar.addSeparator('sep' + self.countSeparator.toString() , index);
				self.countSeparator++;
			};
		},
		
		_customGrid: function (){
			var self = this;
			
			this.grid._loadData = function (self){
                self.layout.progressOn();
                self.dataGrid.load(self.grid.url, function(){
					self.layout.progressOff();
				});
			};
			
			if(this.grid.refresh == undefined)
				this.grid.refresh = function (self){
				this.grid._loadData(self);
			}
			
		},
		
		getButton: function (id){
			if(this._defaultButtons[id] != undefined)
				return this._defaultButtons[id]; 
			
			for(var x = 0; x < this.buttons.length; x++){
				if(typeof(this.buttons[x]) == "string")
					try{
						if(this._defaultButtons[this.buttons[x]].id == id)
							return this._defaultButtons[this.buttons[x]];
					} catch(e){}
				else
					if(this.buttons[x].id == id)
						return this.buttons[x];
			}
		},
		
		getLayout: function (){
			return this.layout;
		},
		
		getGrid: function (){
			return this.dataGrid;
		},
		
		getToolbar: function (){
			return this.toolbar;
		}
	};
	
	smsDefaultUI._init(data);
	return smsDefaultUI;
}
